//============================================================================
// 635_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
// LED_Editor.cpp : implementation file
//

#include "stdafx.h"
#include "635_wintest.h"
#include "serial.h"
#include "GPIO.h"
#include "KeyPads.h"
#include "TempsDlg.h"
#include "Fans.h"
#include "Packet_Debug.h"
#include "Live_Display.h"
#include "LED_Editor.h"
#include "635_WinTestDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// LED_Editor dialog

LED_Editor::LED_Editor(CWnd* pParent /*=NULL*/)
	: CDialog(LED_Editor::IDD, pParent)
  {
	//{{AFX_DATA_INIT(LED_Editor)
	//}}AFX_DATA_INIT
  ASSERT(pParent != NULL);

  m_pParent = pParent;
  m_nID = LED_Editor::IDD;
  }

BOOL LED_Editor::OnInitDialog()
  {
  CDialog::OnInitDialog();

  int
    led;
  for(led=0;led<=3;led++)
    {
    //Set the control's default position
    char
      string[10];

    m_Green_Slider[led].SetRange(0,100);
    m_Green_Slider[led].SetPos(100-(last_green_levels[led]=0));
    sprintf(string,"%d%%",last_green_levels[led]);
    m_Green_Percent[led].SetWindowText(string);

    m_Red_Slider[led].SetRange(0,100);
    m_Red_Slider[led].SetPos(last_red_levels[led]=0);
    sprintf(string,"%d%%",last_red_levels[led]);
    m_Red_Percent[led].SetWindowText(string);
    }

  LED_Mouse_Focus=-1;

  return TRUE;
  }

void LED_Editor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(LED_Editor)
	DDX_Control(pDX, IDC_GREEN_PERCENT_0, m_Green_Percent[0]);
	DDX_Control(pDX, IDC_GREEN_PERCENT_1, m_Green_Percent[1]);
	DDX_Control(pDX, IDC_GREEN_PERCENT_2, m_Green_Percent[2]);
	DDX_Control(pDX, IDC_GREEN_PERCENT_3, m_Green_Percent[3]);
	DDX_Control(pDX, IDC_GREEN_SLIDER_0, m_Green_Slider[0]);
	DDX_Control(pDX, IDC_GREEN_SLIDER_1, m_Green_Slider[1]);
	DDX_Control(pDX, IDC_GREEN_SLIDER_2, m_Green_Slider[2]);
	DDX_Control(pDX, IDC_GREEN_SLIDER_3, m_Green_Slider[3]);
	DDX_Control(pDX, IDC_RED_PERCENT_0, m_Red_Percent[0]);
	DDX_Control(pDX, IDC_RED_PERCENT_1, m_Red_Percent[1]);
	DDX_Control(pDX, IDC_RED_PERCENT_2, m_Red_Percent[2]);
	DDX_Control(pDX, IDC_RED_PERCENT_3, m_Red_Percent[3]);
	DDX_Control(pDX, IDC_RED_SLIDER_0, m_Red_Slider[0]);
	DDX_Control(pDX, IDC_RED_SLIDER_1, m_Red_Slider[1]);
	DDX_Control(pDX, IDC_RED_SLIDER_2, m_Red_Slider[2]);
	DDX_Control(pDX, IDC_RED_SLIDER_3, m_Red_Slider[3]);
	//}}AFX_DATA_MAP
}

//Allows both ON_WM_CLOSE and ON_BN_CLICKED(IDC_HIDE_LEDS, ) to map to
//a single function with out breaking the resource editor,
#define OnDone OnClose

BEGIN_MESSAGE_MAP(LED_Editor, CDialog)
	//{{AFX_MSG_MAP(LED_Editor)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
  ON_WM_VSCROLL()
  ON_WM_HSCROLL()
  ON_WM_CLOSE()
  ON_BN_CLICKED(IDC_HIDE_LEDS, OnDone)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

////////////////////////////////////////////////////////////////////////////
BOOL LED_Editor::Create()
  {
  return CDialog::Create(m_nID, m_pParent);
  }
/////////////////////////////////////////////////////////////////////////////
void LED_Editor::PostNcDestroy()
  {
  delete this;
  }
/////////////////////////////////////////////////////////////////////////////
void LED_Editor::OnClose() 
  {
  ((CMy635_WinTestDlg*)m_pParent)->LED_Editor_Done();
  }
/////////////////////////////////////////////////////////////////////////////
//There is probably some clever way to find out where the bitmaps
//are in our window. I just picked the X coordinates off the screen.
const static int
  x_coords[4]={83,290,497,701};
//All the Y coordiantes are 29, the bitmaps are 101x101 (0,1, . . . 99,100)
//---------------------------------------------------------------------------
#define BORDER 10
void LED_Editor::OnLButtonDown(UINT nFlags, CPoint point) 
  {
  //Assume we are not inside any of the bitmaps
  LED_Mouse_Focus=-1;
 
  int
    led;
  for(led=0;led<=3;led++)
    {
    //See if the point is within this LED's bitmap
    if(((x_coords[led]-BORDER)<=point.x)&&
       (point.x<=(x_coords[led]+100+BORDER))&&
       ((29-BORDER)<=point.y)&&
       (point.y<=(BORDER+129)))
      {
      //We are down inside one of the bitmaps. Set the focus to
      //this bitmap.
      LED_Mouse_Focus=led;

      //Set the X/Red slider
      int
        red_val;
      red_val=point.x-x_coords[LED_Mouse_Focus];
      if(red_val<0)
        red_val=0;
      if(100<red_val)
        red_val=100;
      m_Red_Slider[LED_Mouse_Focus].SetPos(red_val);
      UpdateRedSlider();

      //Set the Y/Green slider
      int
        green_val;
      green_val=point.y-29;
      if(green_val<0)
        green_val=0;
      if(100<green_val)
        green_val=100;
      m_Green_Slider[LED_Mouse_Focus].SetPos(green_val);
      UpdateGreenSlider();
      }
    }
  //Do the default processing
	CDialog::OnLButtonDown(nFlags, point);
  }
/////////////////////////////////////////////////////////////////////////////
void LED_Editor::OnMouseMove(UINT nFlags, CPoint point) 
  {
  //For a move to send updates, one of the bitmaps must be 
  //in "focus" (ours, not the systems) and the mouse must
  //be within that bitmap.
  if((LED_Mouse_Focus!=-1)&&
     ((x_coords[LED_Mouse_Focus]-BORDER)<=point.x)&&
     (point.x<=(x_coords[LED_Mouse_Focus]+100+BORDER))&&
     ((29-BORDER)<=point.y)&&
     (point.y<=(BORDER+129)))
    {
    //Set the X/Red slider
    int
      red_val;
    red_val=point.x-x_coords[LED_Mouse_Focus];
    if(red_val<0)
      red_val=0;
    if(100<red_val)
      red_val=100;
    m_Red_Slider[LED_Mouse_Focus].SetPos(red_val);
    UpdateRedSlider();
    //Set the Y/Green slider
    int
      green_val;
    green_val=point.y-29;
    if(green_val<0)
      green_val=0;
    if(100<green_val)
      green_val=100;
    m_Green_Slider[LED_Mouse_Focus].SetPos(green_val);
    UpdateGreenSlider();
    }
  //Do the default processing
	CDialog::OnMouseMove(nFlags, point);
  }
/////////////////////////////////////////////////////////////////////////////
void LED_Editor::OnLButtonUp(UINT nFlags, CPoint point) 
  {
  //Since the button is coming up, none of our
  //bitmaps are in "focus" any more.
  LED_Mouse_Focus=-1;
  //Do the default processing
	CDialog::OnLButtonUp(nFlags, point);
  }
/////////////////////////////////////////////////////////////////////////////
void LED_Editor::UpdateRedSlider(void) 
  {
//  COMMAND_PACKET
//    set_led_level_packet;
  int
    led;
  for(led=0;led<=3;led++)
    {
    int
      new_led_level;

    new_led_level=m_Red_Slider[led].GetPos();
    //See if there is a change
    if(last_red_levels[led]!=new_led_level)
      {
      //remember the change
      last_red_levels[led]=new_led_level;
      //update the level reading on the screen
      char
        string[10];

      sprintf(string,"%d%%",last_red_levels[led]);
      m_Red_Percent[led].SetWindowText(string);
      //Fill out the packet
      COMMAND_PACKET
        set_led_level_packet;
      set_led_level_packet.command=34;
      set_led_level_packet.data_length=2;
      set_led_level_packet.data[0]=((3-led)*2)+6;
      set_led_level_packet.data[1]=new_led_level;
      //Send the packet to the module
      ((CMy635_WinTestDlg*)m_pParent)->QueuePacket(&set_led_level_packet);
      }
    }
  }
//---------------------------------------------------------------------------
void LED_Editor::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
  {
  UpdateRedSlider();
  //Do the default processing
  CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
  }
/////////////////////////////////////////////////////////////////////////////
void LED_Editor::UpdateGreenSlider(void) 
  {
  int
    led;
  for(led=0;led<=3;led++)
    {
    int
      new_led_level;

    new_led_level=100-m_Green_Slider[led].GetPos();
    //See if there is a change
    if(last_green_levels[led]!=new_led_level)
      {
      //remember the change
      last_green_levels[led]=new_led_level;
      //update the level reading on the screen
      char
        string[10];
      sprintf(string,"%d%%",last_green_levels[led]);
      m_Green_Percent[led].SetWindowText(string);

      //Fill out the packet
      COMMAND_PACKET
        set_led_level_packet;
      set_led_level_packet.command=34;
      set_led_level_packet.data_length=2;
      set_led_level_packet.data[0]=((3-led)*2)+5;
      set_led_level_packet.data[1]=new_led_level;
      //Send the packet to the module
      ((CMy635_WinTestDlg*)m_pParent)->QueuePacket(&set_led_level_packet);
      }
    }
  }
//---------------------------------------------------------------------------
void LED_Editor::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
  {
  UpdateGreenSlider();
  //Do the default processing
  CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
  }
/////////////////////////////////////////////////////////////////////////////

